////////////////////////////////////////////////////////////////////////
// recordings_widget.cpp
// generated with ecppc
//

#include <tnt/ecpp.h>
#include <tnt/httprequest.h>
#include <tnt/httpreply.h>
#include <tnt/httpheader.h>
#include <tnt/http.h>
#include <tnt/data.h>
#include <tnt/componentfactory.h>
#include <cxxtools/log.h>
#include <stdexcept>

log_define("component.recordings_widget")

// <%pre>
#line 1 "recordings_widget.ecpp"

#include <exception.h>
#include <setup.h>
#include <recman.h>
#include <tools.h>
#include <stringhelpers.h>

using namespace vdrlive;


// </%pre>

namespace
{
class _component_ : public tnt::EcppComponent
{
    _component_& main()  { return *this; }

  protected:
    ~_component_();

  public:
    _component_(const tnt::Compident& ci, const tnt::Urlmapper& um, tnt::Comploader& cl);

    unsigned operator() (tnt::HttpRequest& request, tnt::HttpReply& reply, tnt::QueryParams& qparam);
};

static tnt::EcppComponentFactoryImpl<_component_> Factory("recordings_widget");

static const char* rawData = "4\000\000\000B\000\000\000H\000\000\000J\000\000\000L\000\000\000i\000\000\000j\000\000"
  "\000k\000\000\000l\000\000\000s\000\000\000u\000\000\000\203\000\000\000\215\000\000\000<select name=\"\" id=\"\" >\n"
  "    <option value=\"recording_\">\n      ()\n    </option>\n</select>\n";

// <%shared>
// </%shared>

// <%config>
// </%config>

_component_::_component_(const tnt::Compident& ci, const tnt::Urlmapper& um, tnt::Comploader& cl)
  : EcppComponent(ci, um, cl)
{
  // <%init>
  // </%init>
}

_component_::~_component_()
{
  // <%cleanup>
  // </%cleanup>
}

template <typename T>
inline void _tnt_ignore_unused(const T&) { }

unsigned _component_::operator() (tnt::HttpRequest& request, tnt::HttpReply& reply, tnt::QueryParams& qparam)
{
  log_trace("recordings_widget " << qparam.getUrl());

  tnt::DataChunks _tntChunks(rawData);

  // <%args>
std::string name = qparam.get< std::string >("name", ( "recid"));
std::string selected = qparam.get< std::string >("selected");
std::string onchange = qparam.get< std::string >("onchange");
  // </%args>

#line 17 "recordings_widget.ecpp"
  typedef bool logged_in_type;
  TNT_SESSION_SHARED_VAR(bool, logged_in, (false));   // <%session> bool logged_in(false)
  _tnt_ignore_unused<logged_in_type>(logged_in);
#line 18 "recordings_widget.ecpp"
  typedef std::string prev_recording_type;
  TNT_SESSION_SHARED_VAR(std::string, prev_recording, ());   // <%session> std::string prev_recording
  _tnt_ignore_unused<prev_recording_type>(prev_recording);
#line 19 "recordings_widget.ecpp"
  typedef std::string next_recording_type;
  TNT_SESSION_SHARED_VAR(std::string, next_recording, ());   // <%session> std::string next_recording
  _tnt_ignore_unused<next_recording_type>(next_recording);
  // <%cpp>
#line 21 "recordings_widget.ecpp"
 if (!logged_in && LiveSetup().UseAuth()) return reply.redirect("login.html");

  reply.out() << _tntChunks[0]; // <select name="
#line 22 "recordings_widget.ecpp"
  reply.sout() << ( name );
  reply.out() << _tntChunks[1]; // " id="
#line 22 "recordings_widget.ecpp"
  reply.sout() << ( name );
  reply.out() << _tntChunks[2]; // " 
#line 22 "recordings_widget.ecpp"
 reply.out() << ( !onchange.empty() ? "onchange=\""+onchange+"\"" : "" ); 
  reply.out() << _tntChunks[3]; // >\n
#line 23 "recordings_widget.ecpp"

  cToSvConcat<0> recId;
  bool selectedFound = false;
  next_recording = "";
  recId.reserve(8 + 128/4);  // 32 hash bytes (4 bits per hex digit) plus some spare bytes
  eSortOrder sortOrder = vdrlive::eSortOrder::name; // default
  RecordingsTreePtr recordingsTree(LiveRecordingsManager()->GetRecordingsTree());
  const std::vector<RecordingsItemRecPtr>* allRecordings = recordingsTree->allRecordings(sortOrder);
  for (const RecordingsItemRecPtr &rPtr : *allRecordings ) {
    if (!selectedFound) {
      prev_recording = recId.c_str();
    }
    recId.clear();
    recId.appendHex(rPtr->IdHash().high64, 16);
    recId.appendHex(rPtr->IdHash().low64, 16);
    bool isSelected = strcmp( recId.c_str(), selected.c_str() ) == 0;

  reply.out() << _tntChunks[4]; //     <option value="recording_
#line 40 "recordings_widget.ecpp"
  reply.out() << ( recId.c_str() );
  reply.out() << _tntChunks[5]; // "
#line 40 "recordings_widget.ecpp"
  if ( isSelected )
    reply.sout() <<  " selected=\"selected\"" ;
  reply.out() << _tntChunks[6]; // >
#line 40 "recordings_widget.ecpp"
  reply.sout() << ( rPtr->Name() );
  reply.out() << _tntChunks[7]; // \n
#line 41 "recordings_widget.ecpp"

    std::string folder = (const char*)rPtr->Recording()->Folder();
    if (!folder.empty()) {

  reply.out() << _tntChunks[8]; //       (
#line 45 "recordings_widget.ecpp"
  reply.sout() << ( folder );
  reply.out() << _tntChunks[9]; // )\n
#line 46 "recordings_widget.ecpp"
    }

  reply.out() << _tntChunks[10]; //     </option>\n
#line 48 "recordings_widget.ecpp"

    if (selectedFound && next_recording.empty()) {
      next_recording = recId.c_str();
    }
    selectedFound |= isSelected;
  }

  reply.out() << _tntChunks[11]; // </select>\n
  // <%/cpp>
  return DEFAULT;
}

} // namespace
