////////////////////////////////////////////////////////////////////////
// timers.cpp
// generated with ecppc
//

#include <tnt/ecpp.h>
#include <tnt/httprequest.h>
#include <tnt/httpreply.h>
#include <tnt/httpheader.h>
#include <tnt/http.h>
#include <tnt/data.h>
#include <tnt/componentfactory.h>
#include <cxxtools/log.h>
#include <stdexcept>

log_define("component.timers")

// <%pre>
#line 1 "timers.ecpp"


#include <timers.h>
#include <tools.h>
#include <setup.h>
#include <epg_events.h>
#include <timerconflict.h>
#include <livefeatures.h>
#include <users.h>

using namespace vdrlive;


#line 1 "page_init.eh"

// do not add to Makefile
// and do not write a ecpp comment into this file. It must produce no
// HTML output not even an empty line.
#include <tnt/savepoint.h>
#include <exception.h>

#line 2 "page_exit.eh"

#include <exception.h>

// </%pre>

namespace
{
class _component_ : public tnt::EcppComponent
{
    _component_& main()  { return *this; }

  protected:
    ~_component_();

  public:
    _component_(const tnt::Compident& ci, const tnt::Urlmapper& um, tnt::Comploader& cl);

    unsigned operator() (tnt::HttpRequest& request, tnt::HttpReply& reply, tnt::QueryParams& qparam);
    class timer_actions_type : public tnt::EcppSubComponent
    {
        _component_& mainComp;
        _component_& main()  { return mainComp; }

      public:
        timer_actions_type(_component_& m, const std::string& name)
          : EcppSubComponent(m, name),
            mainComp(m)
          { }
        unsigned operator() (tnt::HttpRequest& request, tnt::HttpReply& reply, tnt::QueryParams& qparam);
    };

    timer_actions_type timer_actions;
};

static tnt::EcppComponentFactoryImpl<_component_> Factory("timers");

static const char* rawData = "|\001\000\000\306\001\000\0008\002\000\000E\002\000\000J\002\000\000O\002\000\000\231\002"
  "\000\000\236\002\000\000\270\002\000\000\300\002\000\000\301\002\000\000\377\002\000\000R\003\000\000\304\003\000\000"
  "\260\004\000\000\001\005\000\000R\005\000\000\243\005\000\000\364\005\000\000&\006\000\000T\006\000\000y\006\000\000"
  "\232\006\000\000\264\006\000\000k\010\000\000\224\010\000\000\240\010\000\000\251\010\000\000\252\010\000\000\307\010"
  "\000\000B\t\000\000E\t\000\000\234\t\000\000\245\t\000\000\247\t\000\000\250\t\000\000\251\t\000\000\253\t\000\000"
  "\331\t\000\000\356\t\000\000&\n\000\000(\n\000\000K\n\000\000\203\n\000\000\205\n\000\000\250\n\000\000\340\n\000\000"
  "\342\n\000\000\003\013\000\000;\013\000\000=\013\000\000^\013\000\000y\013\000\000\210\013\000\000\253\013\000\000"
  "\272\013\000\000\277\013\000\000\313\013\000\000\314\013\000\000\004\014\000\000\005\014\000\000-\014\000\000N\014"
  "\000\000O\014\000\000j\014\000\000w\014\000\000x\014\000\000\242\014\000\000\245\014\000\000\252\014\000\000\343\014"
  "\000\000\345\014\000\000\352\014\000\000\025\015\000\000c\015\000\000}\015\000\000\206\015\000\000\250\015\000\000"
  "\336\015\000\000\t\016\000\000L\016\000\000f\016\000\000o\016\000\000\237\016\000\000\333\016\000\000\365\016\000\000"
  "\376\016\000\000\032\017\000\000F\017\000\000G\017\000\000H\017\000\000b\017\000\000g\017\000\000\240\017\000\000\245"
  "\017\000\000<!DOCTYPE html>\n<html>\n  <script>\n    history.go(-1);\n  </script>\n</html>\n\n<html>\n  <head>\n    <"
  "meta name=\"viewport\" content=\"width=device-width, initial-scale=1\" />\n    <title>VDR-Live - </title>\n    \n    "
  "\n    \n  </head>\n  <body onload=\"adjustHeader()\" onresize=\"adjustHeader()\">\n    \n    \n    <div class=\"inhal"
  "t\">\n        \n      <table class=\"listing\" cellspacing=\"0\" cellpadding=\"0\">\n            <tr class=\"spacer\""
  ">\n              <td colspan=\"12\"/>\n            </tr>\n        <tr class=\"head\">\n          <td colspan=\"12\">"
  "\n            <div class=\"boxheader\"><div><div>\n              \n            </div></div></div>\n          </td>\n "
  "       </tr>\n        <tr class=\"description\">\n          <td class=\"leftcol\"><img src=\"img/transparent.png\" al"
  "t=\"\" width=\"16px\" height=\"16px\" /></td>\n          <td><div class=\"withmargin\"></div></td>\n          <td cla"
  "ss=\"td-hidden-xs\"><div class=\"withmargin hidden-xs\"></div></td>\n          <td class=\"td-hidden-xs\"><div class="
  "\"withmargin hidden-xs\"></div></td>\n          <td class=\"td-hidden-xs\"><div class=\"withmargin hidden-xs\"></div>"
  "</td>\n          <td class=\"td-hidden-xs\"><div class=\"withmargin hidden-xs\"></div></td>\n          <td><div class"
  "=\"withmargin\"></div></td>\n          <td class=\"td-hidden-xs \"><div class=\"xs-nomargin hidden-xs\"></div></td>\n"
  "          <td class=\"\"><div class=\"withmargin\"></div></td>\n\n          <td class=\"td-hidden-xs\"><img class=\"h"
  "idden-xs action-rightcol\" src=\"img/transparent.png\" alt=\"\" width=\"16px\" height=\"16px\" /></td>\n          <td"
  " class=\"td-hidden-xs\"><img class=\"hidden-xs action-rightcol\" src=\"img/transparent.png\" alt=\"\" width=\"16px\" "
  "height=\"16px\" /></td>\n          <td class=\"rightcol\"><img class=\"action-rightcol\" src=\"img/transparent.png\" "
  "alt=\"\" width=\"16px\" height=\"16px\" /></td>\n        </tr>\n        <tr>\n\n        <td class=\"leftcol \"><img s"
  "rc=\"\" alt=\"\"  /></td>\n          <td class=\"\"><div class=\"withmargin\">\n             <table class=\"noborder"
  "\"><tr><td class=\"noborder\"><span class=\"display-xs nowrap\" >  - </span></td></tr>\n             <tr><td class=\""
  "noborder\"><a href=\"schedule.html\?channel=\" title=\": --\"></a></td></tr>\n</table>\n          </div></td>\n      "
  "    <td class=\" td-hidden-xs\"><div class=\"hidden-xs withmargin nowrap\"  >  </div></td>\n          <td class=\" td"
  "-hidden-xs\"><div class=\"hidden-xs withmargin nowrap\"  >  </div></td>\n          <td class=\" td-hidden-xs\"><div c"
  "lass=\"hidden-xs withmargin nowrap\"  ></div></td>\n          <td class=\" td-hidden-xs\"><div class=\"hidden-xs with"
  "margin nowrap\"  ></div></td>\n          <td class=\"\"><div class=\"withmargin\">\n            <a \n            clas"
  "s=\"apopup\" title=\"\">\n            </a>\n            \n            </div>\n          </td>\n          <td class=\""
  "  td-hidden-xs\"><div class=\"xs-nomargin\"></div></td>\n          <td class=\" \"><div class=\"withmargin\">\n\n    "
  "        \n              <a href=\"epginfo.html\?epgid=\"> </a>\n            <a href=\"edit_searchtimer.html\?searchti"
  "merid=\"></a>\n          </div></td>\n          <td class=\" td-hidden-xs\"><a class=\"hidden-xs action-rightcol\" hr"
  "ef=\"timers.html\?timerid=&action=toggle\"><img src=\"\" alt=\"\"  /></a></td>\n          <td class=\" td-hidden-xs\""
  "><div class=\"hidden-xs action-rightcol\"></div></td>\n\n          <td class=\"rightcol \">\n<a class=\"display-xs ac"
  "tion-rightcol\" href=\"timers.html\?timerid=&action=toggle\"><img src=\"\" alt=\"\"  /></a>\n<div class=\"display-xs "
  "action-rightcol\"></div>\n<a class=\"action-rightcol\" href=\"timers.html\?timerid=&action=delete\"><img src=\"\" alt"
  "=\"\"  /></a></td>\n\n        </tr>\n      </table>\n    </div>\n  </body>\n</html>\n\n\n<a href=\"edit_timer.html\">"
  "</a>\n<span class=\"sep\">|</span>\n<a href=\"timerconflicts.html\"></a>\n";

// <%shared>
// </%shared>

// <%config>
// </%config>

_component_::_component_(const tnt::Compident& ci, const tnt::Urlmapper& um, tnt::Comploader& cl)
  : EcppComponent(ci, um, cl),
    timer_actions(*this, "timer_actions")
{
  // <%init>
  // </%init>
}

_component_::~_component_()
{
  // <%cleanup>
  // </%cleanup>
}

template <typename T>
inline void _tnt_ignore_unused(const T&) { }

unsigned _component_::operator() (tnt::HttpRequest& request, tnt::HttpReply& reply, tnt::QueryParams& qparam)
{
  log_trace("timers " << qparam.getUrl());

  tnt::DataChunks _tntChunks(rawData);

  // <%args>
std::string timerid = qparam.get< std::string >("timerid");
std::string action = qparam.get< std::string >("action");
  // </%args>

#line 20 "timers.ecpp"
  typedef bool logged_in_type;
  TNT_SESSION_SHARED_VAR(bool, logged_in, (false));   // <%session> bool logged_in(false)
  _tnt_ignore_unused<logged_in_type>(logged_in);
#line 23 "timers.ecpp"
  typedef const cTimer* timer_type;
  TNT_REQUEST_PAGE_VAR(const cTimer*, timer, ());   // <%request> const cTimer* timer
  _tnt_ignore_unused<timer_type>(timer);
#line 24 "timers.ecpp"
  typedef TimerConflictNotifier timerNotifier_type;
  TNT_REQUEST_PAGE_VAR(TimerConflictNotifier, timerNotifier, ());   // <%request> TimerConflictNotifier timerNotifier
  _tnt_ignore_unused<timerNotifier_type>(timerNotifier);
#line 9 "page_init.eh"
  typedef std::string pageTitle_type;
  TNT_REQUEST_SHARED_VAR(std::string, pageTitle, ());   // <%request> std::string pageTitle
  _tnt_ignore_unused<pageTitle_type>(pageTitle);
  // <%cpp>
  // <%include> page_init.eh
#line 11 "page_init.eh"

try {
  reply.setHeader("Expires", "Mon, 26 Jul 1997 05:00:00 GMT");
  tnt::Savepoint spoint( reply );

  // </%include>
#line 27 "timers.ecpp"

  reply.setHeader (tnt::httpheader::cacheControl, "no-store, no-cache, max-age=0, must-revalidate, proxy-revalidate", true);
  if (!logged_in && LiveSetup().UseAuth()) return reply.redirect("login.html");

  pageTitle = trVDR("Timers");

  cMutexLock timersLock( &LiveTimerManager() );
  SortedTimers& timers = LiveTimerManager().GetTimers();
  TimerConflicts timerConflicts;

  timer = 0;
  if ( !timerid.empty()  && !action.empty() ) {
    std::string tId = SortedTimers::DecodeDomId(timerid);
//    dsyslog("live: DEBUG: TIMER: tId = %s", tId.c_str());
    timer = timers.GetByTimerId(tId);
    if ( timer == 0 )
      throw HtmlError( tr("Couldn't find timer. Maybe you mistyped your request?") );
    if (action == "delete") {
      if (!cUser::CurrentUserHasRightTo(UR_DELTIMERS))
        throw HtmlError( tr("Sorry, no permission. Please contact your administrator!") );
//                        dsyslog("live: timers.ecpp timer->Id() %d", timer->Id());
//                        dsyslog("live: timers.ecpp timer->Remote() %s", timer->Remote());
      LiveTimerManager().DelTimer(timer->Id(), timer->Remote());
      timerNotifier.SetTimerModification();
    }
    if (action == "toggle") {
      LiveTimerManager().ToggleTimerActive(timer->Id(), timer->Remote());
      timerNotifier.SetTimerModification();
    }

  reply.out() << _tntChunks[0]; // <!DOCTYPE html>\n<html>\n  <script>\n    history.go(-1);\n  </script>\n</html>\n
#line 63 "timers.ecpp"

  } else {

  std::string previousDay = "";

  // <& pageelems.doc_type ...
  { 
#line 68 "timers.ecpp"
    tnt::QueryParams _tnt_cq0;
#line 68 "timers.ecpp"
    callComp(tnt::Subcompident(std::string(), "pageelems", "doc_type"), request, reply, _tnt_cq0);
    // &>
  }
  reply.out() << _tntChunks[1]; // \n<html>\n  <head>\n    <meta name="viewport" content="width=device-width, initial-scale=1" />\n    <title>VDR-Live - 
#line 72 "timers.ecpp"
  reply.sout() << ( pageTitle );
  reply.out() << _tntChunks[2]; // </title>\n    
  // <& pageelems.stylesheets ...
  { 
#line 73 "timers.ecpp"
    tnt::QueryParams _tnt_cq1;
#line 73 "timers.ecpp"
    callComp(tnt::Subcompident(std::string(), "pageelems", "stylesheets"), request, reply, _tnt_cq1);
    // &>
  }
  reply.out() << _tntChunks[3]; // \n    
  // <& pageelems.ajax_js ...
  { 
#line 74 "timers.ecpp"
    tnt::QueryParams _tnt_cq2;
#line 74 "timers.ecpp"
    callComp(tnt::Subcompident(std::string(), "pageelems", "ajax_js"), request, reply, _tnt_cq2);
    // &>
  }
  reply.out() << _tntChunks[4]; // \n    
  // <& pageelems.create_html_js ...
  { 
#line 75 "timers.ecpp"
    tnt::QueryParams _tnt_cq3;
#line 75 "timers.ecpp"
    callComp(tnt::Subcompident(std::string(), "pageelems", "create_html_js"), request, reply, _tnt_cq3);
    // &>
  }
  reply.out() << _tntChunks[5]; // \n  </head>\n  <body onload="adjustHeader()" onresize="adjustHeader()">\n    
  // <& pageelems.logo ...
  { 
#line 78 "timers.ecpp"
    tnt::QueryParams _tnt_cq4;
#line 78 "timers.ecpp"
    callComp(tnt::Subcompident(std::string(), "pageelems", "logo"), request, reply, _tnt_cq4);
    // &>
  }
  reply.out() << _tntChunks[6]; // \n    
  // <& menu ...
  { 
#line 79 "timers.ecpp"
    tnt::QueryParams _tnt_cq5;
#line 79 "timers.ecpp"
    _tnt_cq5.add( "active", ("timers"));
#line 79 "timers.ecpp"
    _tnt_cq5.add( "component", ("timers.timer_actions"));
#line 79 "timers.ecpp"
    callComp(tnt::Compident(std::string(), "menu"), request, reply, _tnt_cq5);
    // &>
  }
  reply.out() << _tntChunks[7]; // \n    <div class="inhalt">\n
#line 81 "timers.ecpp"

    #ifdef DEBUG_LOCK
      dsyslog("live: pages/timers.ecpp LOCK_TIMERS_READ");
    #endif
      LOCK_TIMERS_READ;
      cSortedTimers sortedTimers(Timers);
      if (sortedTimers.Size() == 0) {

  reply.out() << _tntChunks[8]; //         
#line 89 "timers.ecpp"
  reply.sout() << ( tr("No timer defined") );
  reply.out() << _tntChunks[9]; // \n
#line 90 "timers.ecpp"
      } else {

  reply.out() << _tntChunks[10]; //       <table class="listing" cellspacing="0" cellpadding="0">\n
#line 92 "timers.ecpp"

        // check for remote timers:
        bool noRemoteTimers = true;
        for (int i = 0; noRemoteTimers && i < sortedTimers.Size(); i++) {
          noRemoteTimers &= sortedTimers[i]->Local();
        }
        // check for search timers or tvscraper autotimer:
        bool noSearchTimers = true;
        for (int i = 0; noSearchTimers && i < sortedTimers.Size(); i++) {
          std::string recID;
          std::string recName;
          timer = sortedTimers[i];
          noSearchTimers &= timer->Local() && SortedTimers::SearchTimerInfo(*timer, "s-id").empty() && SortedTimers::TvScraperTimerInfo(*timer, recID, recName).empty();
        }
        // output of the timer list:
        for (int i = 0; i < sortedTimers.Size(); i++) {
          const cTimer *timer = sortedTimers[i];
          EpgInfoPtr epgEvent = 0;
          std::string longDescription;
          std::string searchTimName;
          std::string searchTimId;
          std::string recID;
          std::string recName;

          longDescription  = StringEscapeAndBreak(SortedTimers::GetTimerInfo(*timer));
          if (timer->Event())
          {
            epgEvent = EpgEvents::CreateEpgInfo(timer->Channel(), timer->Event());
            bool truncated = false;
            if (epgEvent->LongDescr().length()) longDescription += "<hr>";
            longDescription += StringEscapeAndBreak(StringWordTruncate(epgEvent->LongDescr(), LiveSetup().GetMaxTooltipChars(), truncated));
            if (truncated) longDescription += " ...";
          }
          AppendHtmlEscapedAndCorrectNonUTF8(searchTimName, SortedTimers::SearchTimerInfo(*timer, "searchtimer"));
          searchTimId = SortedTimers::SearchTimerInfo(*timer, "s-id");
          if (searchTimName.empty() && searchTimId.empty() ) AppendHtmlEscapedAndCorrectNonUTF8(searchTimName, SortedTimers::TvScraperTimerInfo(*timer, recID, recName) );
          std::string currentDay = SortedTimers::GetTimerDays(timer);
          const cTimer *nextTimer =  NULL;
          if (i < (sortedTimers.Size() - 1)) nextTimer = sortedTimers[i + 1];
          bool bottom = false;
          if (i == sortedTimers.Size() - 1) bottom = true;
          else {
            std::string nextDay = SortedTimers::GetTimerDays(nextTimer);
            bottom = (currentDay != nextDay);
          }
          if (previousDay != currentDay) {
            if (!previousDay.empty()) {

  reply.out() << _tntChunks[11]; //             <tr class="spacer">\n              <td colspan="12"/>\n            </tr>\n
#line 143 "timers.ecpp"

            }
            previousDay = currentDay;

  reply.out() << _tntChunks[12]; //         <tr class="head">\n          <td colspan="12">\n            <div class="boxheader"><div><div>\n              
#line 150 "timers.ecpp"
  reply.sout() << ( currentDay );
  reply.out() << _tntChunks[13]; // \n            </div></div></div>\n          </td>\n        </tr>\n        <tr class="description">\n          <td class="leftcol"><img src="img/transparent.png" alt="" width="16px" height="16px" /></td>\n          <td><div class="withmargin">
#line 156 "timers.ecpp"
  reply.sout() << ( trVDR("Channel") );
  reply.out() << _tntChunks[14]; // </div></td>\n          <td class="td-hidden-xs"><div class="withmargin hidden-xs">
#line 157 "timers.ecpp"
  reply.sout() << ( trVDR("Start") );
  reply.out() << _tntChunks[15]; // </div></td>\n          <td class="td-hidden-xs"><div class="withmargin hidden-xs">
#line 158 "timers.ecpp"
  reply.sout() << ( trVDR("Stop")  );
  reply.out() << _tntChunks[16]; // </div></td>\n          <td class="td-hidden-xs"><div class="withmargin hidden-xs">
#line 159 "timers.ecpp"
  reply.sout() << ( tr("Duration") );
  reply.out() << _tntChunks[17]; // </div></td>\n          <td class="td-hidden-xs"><div class="withmargin hidden-xs">
#line 160 "timers.ecpp"
  reply.sout() << ( trVDR("Priority") );
  reply.out() << _tntChunks[18]; // </div></td>\n          <td><div class="withmargin">
#line 161 "timers.ecpp"
  reply.sout() << ( trVDR("File") );
  reply.out() << _tntChunks[19]; // </div></td>\n          <td class="td-hidden-xs 
#line 162 "timers.ecpp"
  if ( noRemoteTimers )
    reply.sout() <<  "notpresent" ;
  reply.out() << _tntChunks[20]; // "><div class="xs-nomargin hidden-xs">
#line 162 "timers.ecpp"
  reply.sout() << ( trVDR("Record on") );
  reply.out() << _tntChunks[21]; // </div></td>\n          <td class="
#line 163 "timers.ecpp"
  if ( noSearchTimers )
    reply.sout() <<  "notpresent" ;
  reply.out() << _tntChunks[22]; // "><div class="withmargin">
#line 163 "timers.ecpp"
  reply.sout() << ( tr("Search timer") );
  reply.out() << _tntChunks[23]; // </div></td>\n\n          <td class="td-hidden-xs"><img class="hidden-xs action-rightcol" src="img/transparent.png" alt="" width="16px" height="16px" /></td>\n          <td class="td-hidden-xs"><img class="hidden-xs action-rightcol" src="img/transparent.png" alt="" width="16px" height="16px" /></td>\n          <td class="rightcol"><img class="action-rightcol" src="img/transparent.png" alt="" width="16px" height="16px" /></td>\n        </tr>\n
#line 169 "timers.ecpp"

          }
          std::string timerStateImg = "transparent.png";
          std::string timerStateHint;
          if (timer->Recording()) {
            timerStateImg = "arrow_rec.gif";
            timerStateHint = tr("Timer is recording.");
          }
          else if (timer->Flags() & tfActive) {
            if (timerConflicts.HasConflict(timer->Id() )) {
              timerStateImg = "timerconflict.gif";
              timerStateHint = tr("Timer has a conflict.");
            }
            else {
              timerStateImg = "arrow.png";
              timerStateHint = tr("Timer is active.");
            }
          }
          std::string timerFile;
          AppendHtmlEscapedAndCorrectNonUTF8(timerFile, timer->File());

  reply.out() << _tntChunks[24]; //         <tr>\n\n        <td class="leftcol 
#line 192 "timers.ecpp"
  if ( bottom )
    reply.sout() <<  "bottomrow" ;
  reply.out() << _tntChunks[25]; // "><img src="
#line 192 "timers.ecpp"
  reply.sout() << ( LiveSetup().GetThemedLink("img", timerStateImg) );
  reply.out() << _tntChunks[26]; // " alt="" 
#line 192 "timers.ecpp"
 if (!timerStateHint.empty()) { 
  // <& tooltip.hint ...
  { 
#line 192 "timers.ecpp"
    tnt::QueryParams _tnt_cq6;
#line 192 "timers.ecpp"
    _tnt_cq6.add( "text", (timerStateHint));
#line 192 "timers.ecpp"
    callComp(tnt::Subcompident(std::string(), "tooltip", "hint"), request, reply, _tnt_cq6);
    // &>
  }
  reply.out() << _tntChunks[27]; //  
#line 192 "timers.ecpp"
 } 
  reply.out() << _tntChunks[28]; // /></td>\n          <td class="
#line 193 "timers.ecpp"
  if ( bottom )
    reply.sout() <<  "bottomrow" ;
  reply.out() << _tntChunks[29]; // "><div class="withmargin">\n             <table class="noborder"><tr><td class="noborder"><span class="display-xs nowrap" > 
#line 194 "timers.ecpp"
  reply.sout() << ( cToSvDateTime(tr("%I:%M %p"), timer->StartTime()) );
  reply.out() << _tntChunks[30]; //  - 
#line 194 "timers.ecpp"
  reply.sout() << ( cToSvDateTime(tr("%I:%M %p"), timer->StopTime()) );
  reply.out() << _tntChunks[31]; // </span></td></tr>\n             <tr><td class="noborder"><a href="schedule.html\?channel=
#line 195 "timers.ecpp"
  reply.sout() << ( timer->Channel()->Number());
  reply.out() << _tntChunks[32]; // " title="
#line 195 "timers.ecpp"
  reply.sout() << (tr("Transponder"));
  reply.out() << _tntChunks[33]; // : 
#line 195 "timers.ecpp"
  reply.sout() << (*cSource::ToString(timer->Channel()->Source() ));
  reply.out() << _tntChunks[34]; // -
#line 195 "timers.ecpp"
  reply.sout() << (cToSvConcat(timer->Channel()->Frequency()));
  reply.out() << _tntChunks[35]; // -
#line 195 "timers.ecpp"
  reply.sout() << (timer->Channel()->Parameters());
  reply.out() << _tntChunks[36]; // ">
#line 195 "timers.ecpp"
  reply.sout() << ( timer->Channel()->Name() );
  reply.out() << _tntChunks[37]; // </a></td></tr>\n</table>\n          </div></td>\n
#line 198 "timers.ecpp"
         std::string longDescriptionTitle = longDescription.empty()?"":"title=\""+longDescription+"\"";

  reply.out() << _tntChunks[38]; //           <td class="
#line 199 "timers.ecpp"
  if ( bottom )
    reply.sout() <<  "bottomrow" ;
  reply.out() << _tntChunks[39]; //  td-hidden-xs"><div class="hidden-xs withmargin nowrap" 
#line 199 "timers.ecpp"
  reply.out() << (longDescriptionTitle);
  reply.out() << _tntChunks[40]; //  >
#line 199 "timers.ecpp"
  reply.sout() << ( cToSvDateTime(tr("%I:%M %p"), timer->StartTime()) );
  reply.out() << _tntChunks[41]; //   </div></td>\n          <td class="
#line 200 "timers.ecpp"
  if ( bottom )
    reply.sout() <<  "bottomrow" ;
  reply.out() << _tntChunks[42]; //  td-hidden-xs"><div class="hidden-xs withmargin nowrap" 
#line 200 "timers.ecpp"
  reply.out() << (longDescriptionTitle);
  reply.out() << _tntChunks[43]; //  >
#line 200 "timers.ecpp"
  reply.sout() << ( cToSvDateTime(tr("%I:%M %p"), timer->StopTime()) );
  reply.out() << _tntChunks[44]; //   </div></td>\n          <td class="
#line 201 "timers.ecpp"
  if ( bottom )
    reply.sout() <<  "bottomrow" ;
  reply.out() << _tntChunks[45]; //  td-hidden-xs"><div class="hidden-xs withmargin nowrap" 
#line 201 "timers.ecpp"
  reply.out() << (longDescriptionTitle);
  reply.out() << _tntChunks[46]; //  >
#line 201 "timers.ecpp"
  reply.sout() << ( FormatDuration(tr("%d:%02d"), timer->StopTime() - timer->StartTime()) );
  reply.out() << _tntChunks[47]; // </div></td>\n          <td class="
#line 202 "timers.ecpp"
  if ( bottom )
    reply.sout() <<  "bottomrow" ;
  reply.out() << _tntChunks[48]; //  td-hidden-xs"><div class="hidden-xs withmargin nowrap" 
#line 202 "timers.ecpp"
  reply.out() << (longDescriptionTitle);
  reply.out() << _tntChunks[49]; //  >
#line 202 "timers.ecpp"
  reply.sout() << ( timer->Priority() );
  reply.out() << _tntChunks[50]; // </div></td>\n          <td class="
#line 203 "timers.ecpp"
  if ( bottom )
    reply.sout() <<  "bottomrow" ;
  reply.out() << _tntChunks[51]; // "><div class="withmargin">\n
#line 204 "timers.ecpp"
         if(epgEvent) {

  reply.out() << _tntChunks[52]; //             <a 
  // <& tooltip.display ...
  { 
#line 205 "timers.ecpp"
    tnt::QueryParams _tnt_cq7;
#line 205 "timers.ecpp"
    _tnt_cq7.add( "domId", (epgEvent->Id()));
#line 205 "timers.ecpp"
    callComp(tnt::Subcompident(std::string(), "tooltip", "display"), request, reply, _tnt_cq7);
    // &>
  }
  reply.out() << _tntChunks[53]; // \n            class="apopup" title="
#line 206 "timers.ecpp"
  reply.out() << (longDescription);
  reply.out() << _tntChunks[54]; // ">\n            
#line 207 "timers.ecpp"
  reply.out() << ( StringReplace(timerFile, "~", "~<wbr>") );
  reply.out() << _tntChunks[55]; // </a>\n
#line 208 "timers.ecpp"
         } else {

  reply.out() << _tntChunks[56]; //             
#line 209 "timers.ecpp"
  reply.out() << ( StringReplace(timerFile, "~", "~<wbr>") );
  reply.out() << _tntChunks[57]; // \n
#line 210 "timers.ecpp"
         }

  reply.out() << _tntChunks[58]; //             </div>\n          </td>\n          <td class="
#line 213 "timers.ecpp"
  if ( bottom )
    reply.sout() <<  "bottomrow" ;
  reply.out() << _tntChunks[59]; //  
#line 213 "timers.ecpp"
  if ( noRemoteTimers )
    reply.sout() <<  "notpresent" ;
  reply.out() << _tntChunks[60]; //  td-hidden-xs"><div class="xs-nomargin">
#line 213 "timers.ecpp"
  reply.sout() << ( timer->Local()?trVDR(" "):timer->Remote() );
  reply.out() << _tntChunks[61]; // </div></td>\n          <td class="
#line 214 "timers.ecpp"
  if ( bottom )
    reply.sout() <<  "bottomrow" ;
  reply.out() << _tntChunks[62]; //  
#line 214 "timers.ecpp"
  if ( noSearchTimers )
    reply.sout() <<  "notpresent" ;
  reply.out() << _tntChunks[63]; // "><div class="withmargin">\n
#line 215 "timers.ecpp"
          if ( !timer->Local() || searchTimId.empty() ) {

  reply.out() << _tntChunks[64]; // \n            
#line 217 "timers.ecpp"
  reply.out() << ( StringReplace(searchTimName, "~", "~<wbr>") );
  reply.out() << _tntChunks[65]; // \n
#line 218 "timers.ecpp"
           if (!recID.empty() ) {

  reply.out() << _tntChunks[66]; //               <a href="epginfo.html\?epgid=
#line 219 "timers.ecpp"
  reply.sout() << ( recID );
  reply.out() << _tntChunks[67]; // "> 
#line 219 "timers.ecpp"
  reply.out() << ( StringReplace(recName, "~", "~<wbr>") );
  reply.out() << _tntChunks[68]; // </a>\n
#line 220 "timers.ecpp"
           }

#line 221 "timers.ecpp"
          } else {

  reply.out() << _tntChunks[69]; //             <a href="edit_searchtimer.html\?searchtimerid=
#line 222 "timers.ecpp"
  reply.sout() << ( searchTimId );
  reply.out() << _tntChunks[70]; // ">
#line 222 "timers.ecpp"
  reply.out() << ( StringReplace(searchTimName, "~", "~<wbr>") );
  reply.out() << _tntChunks[71]; // </a>\n
#line 223 "timers.ecpp"
          }

  reply.out() << _tntChunks[72]; //           </div></td>\n          <td class="
#line 225 "timers.ecpp"
  if ( bottom )
    reply.sout() <<  "bottomrow" ;
  reply.out() << _tntChunks[73]; //  td-hidden-xs"><a class="hidden-xs action-rightcol" href="timers.html\?timerid=
#line 225 "timers.ecpp"
  reply.sout() << ( SortedTimers::EncodeDomId(timers.GetTimerId(*timer)) );
  reply.out() << _tntChunks[74]; // &action=toggle"><img src="
#line 225 "timers.ecpp"
  reply.sout() << ( LiveSetup().GetThemedLink("img", (timer->Flags() & tfActive) ? "active.png" : "inactive.png") );
  reply.out() << _tntChunks[75]; // " alt="" 
  // <& tooltip.hint ...
  { 
#line 225 "timers.ecpp"
    tnt::QueryParams _tnt_cq8;
#line 225 "timers.ecpp"
    _tnt_cq8.add( "text", (tr("Toggle timer active/inactive")));
#line 225 "timers.ecpp"
    callComp(tnt::Subcompident(std::string(), "tooltip", "hint"), request, reply, _tnt_cq8);
    // &>
  }
  reply.out() << _tntChunks[76]; //  /></a></td>\n          <td class="
#line 226 "timers.ecpp"
  if ( bottom )
    reply.sout() <<  "bottomrow" ;
  reply.out() << _tntChunks[77]; //  td-hidden-xs"><div class="hidden-xs action-rightcol">
  // <& pageelems.edit_timer ...
  { 
#line 226 "timers.ecpp"
    tnt::QueryParams _tnt_cq9;
#line 226 "timers.ecpp"
    _tnt_cq9.add( "timerId", (timers.GetTimerId(*timer)));
#line 226 "timers.ecpp"
    callComp(tnt::Subcompident(std::string(), "pageelems", "edit_timer"), request, reply, _tnt_cq9);
    // &>
  }
  reply.out() << _tntChunks[78]; // </div></td>\n\n          <td class="rightcol 
#line 228 "timers.ecpp"
  if ( bottom )
    reply.sout() <<  "bottomrow" ;
  reply.out() << _tntChunks[79]; // ">\n<a class="display-xs action-rightcol" href="timers.html\?timerid=
#line 229 "timers.ecpp"
  reply.sout() << ( SortedTimers::EncodeDomId(timers.GetTimerId(*timer)) );
  reply.out() << _tntChunks[80]; // &action=toggle"><img src="
#line 229 "timers.ecpp"
  reply.sout() << ( LiveSetup().GetThemedLink("img", (timer->Flags() & tfActive) ? "active.png" : "inactive.png") );
  reply.out() << _tntChunks[81]; // " alt="" 
  // <& tooltip.hint ...
  { 
#line 229 "timers.ecpp"
    tnt::QueryParams _tnt_cq10;
#line 229 "timers.ecpp"
    _tnt_cq10.add( "text", (tr("Toggle timer active/inactive")));
#line 229 "timers.ecpp"
    callComp(tnt::Subcompident(std::string(), "tooltip", "hint"), request, reply, _tnt_cq10);
    // &>
  }
  reply.out() << _tntChunks[82]; //  /></a>\n<div class="display-xs action-rightcol">
  // <& pageelems.edit_timer ...
  { 
#line 230 "timers.ecpp"
    tnt::QueryParams _tnt_cq11;
#line 230 "timers.ecpp"
    _tnt_cq11.add( "timerId", (timers.GetTimerId(*timer)));
#line 230 "timers.ecpp"
    callComp(tnt::Subcompident(std::string(), "pageelems", "edit_timer"), request, reply, _tnt_cq11);
    // &>
  }
  reply.out() << _tntChunks[83]; // </div>\n<a class="action-rightcol" href="timers.html\?timerid=
#line 231 "timers.ecpp"
  reply.sout() << ( SortedTimers::EncodeDomId(timers.GetTimerId(*timer)) );
  reply.out() << _tntChunks[84]; // &action=delete"><img src="
#line 231 "timers.ecpp"
  reply.sout() << ( LiveSetup().GetThemedLink("img", "del.png") );
  reply.out() << _tntChunks[85]; // " alt="" 
  // <& tooltip.hint ...
  { 
#line 231 "timers.ecpp"
    tnt::QueryParams _tnt_cq12;
#line 231 "timers.ecpp"
    _tnt_cq12.add( "text", (tr("Delete timer")));
#line 231 "timers.ecpp"
    callComp(tnt::Subcompident(std::string(), "tooltip", "hint"), request, reply, _tnt_cq12);
    // &>
  }
  reply.out() << _tntChunks[86]; //  /></a></td>\n\n        </tr>\n
#line 234 "timers.ecpp"

        }
      }

  reply.out() << _tntChunks[87]; //       </table>\n    </div>\n  </body>\n</html>\n
#line 242 "timers.ecpp"
 }

  // <%include> page_exit.eh
  reply.out() << _tntChunks[88]; // \n
#line 5 "page_exit.eh"

  spoint.commit();
} catch ( vdrlive::HtmlError const& ex ) {
  tnt::QueryParams param = qparam;
  param.add( "pageTitle", pageTitle );
  param.add( "errorMessage", ex.what() );
  callComp( "error", request, reply, param );
}

  // </%include>
  reply.out() << _tntChunks[89]; // \n
  // <%/cpp>
  return DEFAULT;
}

unsigned _component_::timer_actions_type::operator() (tnt::HttpRequest& request, tnt::HttpReply& reply, tnt::QueryParams& qparam)
{
  log_trace("timers::timer_actions " << qparam.getUrl());
  tnt::DataChunks _tntChunks(rawData);
#line 23 "timers.ecpp"
  typedef const cTimer* timer_type;
  TNT_REQUEST_PAGE_VAR(const cTimer*, timer, ());   // <%request> const cTimer* timer
  _tnt_ignore_unused<timer_type>(timer);
#line 24 "timers.ecpp"
  typedef TimerConflictNotifier timerNotifier_type;
  TNT_REQUEST_PAGE_VAR(TimerConflictNotifier, timerNotifier, ());   // <%request> TimerConflictNotifier timerNotifier
  _tnt_ignore_unused<timerNotifier_type>(timerNotifier);
#line 20 "timers.ecpp"
  typedef bool logged_in_type;
  TNT_SESSION_SHARED_VAR(bool, logged_in, (false));   // <%session> bool logged_in(false)
  _tnt_ignore_unused<logged_in_type>(logged_in);
#line 9 "page_init.eh"
  typedef std::string pageTitle_type;
  TNT_REQUEST_SHARED_VAR(std::string, pageTitle, ());   // <%request> std::string pageTitle
  _tnt_ignore_unused<pageTitle_type>(pageTitle);
  // <%cpp>
  reply.out() << _tntChunks[90]; // <a href="edit_timer.html">
#line 246 "timers.ecpp"
  reply.sout() << ( tr("New timer") );
  reply.out() << _tntChunks[91]; // </a>\n
#line 247 "timers.ecpp"
 if ( LiveFeatures< features::epgsearch >().Recent() ) {

  reply.out() << _tntChunks[92]; // <span class="sep">|</span>\n<a href="timerconflicts.html">
#line 249 "timers.ecpp"
  reply.sout() << ( tr("Timer conflicts") );
  reply.out() << _tntChunks[93]; // </a>\n
#line 250 "timers.ecpp"
 }

  // <%/cpp>
  return DEFAULT;
}

} // namespace
